/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_MOVINDICE                                                */
/* Tabela : MOVINDICE                                                         */
/*                                                                            */
/* Criao:                                                                   */
/* 29/11/2004 - Ronaldo Amaral Costa                                          */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_MOVINDICE'  and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_MOVINDICE
GO

CREATE TRIGGER DTULTATU_MOVINDICE
ON MOVINDICE
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
	                        (SELECT 'MOVINDICE', NULL, 'CDTPINDICE='+CDTPINDICE+';'+
                                                         'IDPERVALOR='+IDPERVALOR+';'+
                                                         'CDINDICE='+CDINDICE+';'+
                                                         'DTREFIND='+CONVERT(CHAR,DTREFIND,103)+';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE MOVINDICE
      SET DTULTATUMVIN = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(MOVINDICE.CDTPINDICE,0) = ISNULL(INSERTED.CDTPINDICE,0)) AND
            (ISNULL(MOVINDICE.IDPERVALOR,0) = ISNULL(INSERTED.IDPERVALOR,0)) AND
            (ISNULL(MOVINDICE.CDINDICE,0)   = ISNULL(INSERTED.CDINDICE,0))   AND
            (ISNULL(MOVINDICE.VRINDICE,0)   = ISNULL(INSERTED.VRINDICE,0))   AND
            (ISNULL(MOVINDICE.DTREFIND,CONVERT(DATETIME,'31/12/1899')) =
               ISNULL(INSERTED.DTREFIND,CONVERT(DATETIME,'31/12/1899')))    ;
   END;
END;
GO

UPDATE MOVINDICE SET DTULTATUMVIN = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUMVIN IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUMVIN' and
            type = 'D')
   ALTER TABLE MOVINDICE DROP CONSTRAINT DEFAULT_DTULTATUMVIN
GO

ALTER TABLE MOVINDICE ADD CONSTRAINT DEFAULT_DTULTATUMVIN
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUMVIN
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_MOVINDICE','4.11.194';
GO


